Package com.sas.metadata.remote

# Interface Login

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Login extends PrimaryType
Represents login information for a given user in a given authentication domain.

Attributes of Login are:

- `UserID`
- `Password`
- `TrustedOnly`
- `OutboundOnly`

Associations of Login are:

- `AssociatedIdentity`
- `DataSources`
- `Domain`
- `Libraries`

## Usage

To create an instance of this Login, use the `factory` create methods.
Example: create a Login with name "Login_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Login myObject = (Login) factory.createComplexMetadataObject(objectStore, "Login_Object", MetadataObjects.LOGIN, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDIDENTITY_NAME`
  Constant used for the name of the AssociatedIdentity association.
  `static final String`
  `ASSOCIATION_DATASOURCES_NAME`
  Constant used for the name of the DataSources association.
  `static final String`
  `ASSOCIATION_DOMAIN_NAME`
  Constant used for the name of the Domain association.
  `static final String`
  `ASSOCIATION_LIBRARIES_NAME`
  Constant used for the name of the Libraries association.
  `static final String`
  `ATTRIBUTE_OUTBOUNDONLY_NAME`
  Constant used for the name of the OutboundOnly attribute.
  `static final String`
  `ATTRIBUTE_PASSWORD_NAME`
  Constant used for the name of the Password attribute.
  `static final String`
  `ATTRIBUTE_TRUSTEDONLY_NAME`
  Constant used for the name of the TrustedOnly attribute.
  `static final String`
  `ATTRIBUTE_USERID_NAME`
  Constant used for the name of the UserID attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Identity`
  `getAssociatedIdentity()`
  Gets the `Identity` for `AssociatedIdentity`
  `AssociationList`
  `getAssociatedIdentitys()`
  Gets the AssociationList of `AssociatedIdentitys`
  `AssociationList`
  `getAssociatedIdentitys(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedIdentitys`
  `AssociationList`
  `getDataSources()`
  Gets the AssociationList of `DataSources`
  `AssociationList`
  `getDataSources(boolean fGoToServer)`
  Gets the Associationlist of `DataSources`
  `AuthenticationDomain`
  `getDomain()`
  Gets the `AuthenticationDomain` for `Domain`
  `AssociationList`
  `getDomains()`
  Gets the AssociationList of `Domains`
  `AssociationList`
  `getDomains(boolean fGoToServer)`
  Gets the Associationlist of `Domains`
  `AssociationList`
  `getLibraries()`
  Gets the Association list of `Libraries`
  `AssociationList`
  `getLibraries(boolean fGoToServer)`
  Gets the Associationlist of `Libraries`
  `int`
  `getOutboundOnly()`
  Gets the `int` value of `OutboundOnly`
  `int`
  `getOutboundOnlyState()`
  Gets the Metadata State of `OutboundOnly`
  `String`
  `getPassword()`
  Gets the `String` value of `Password`
  `int`
  `getPasswordMaxLength()`
  Gets the maximum length of `Password`
  `int`
  `getPasswordState()`
  Gets the Metadata State of `Password`
  `int`
  `getTrustedOnly()`
  Gets the `int` value of `TrustedOnly`
  `int`
  `getTrustedOnlyState()`
  Gets the Metadata State of `TrustedOnly`
  `String`
  `getUserID()`
  Gets the `String` value of `UserID`
  `int`
  `getUserIDMaxLength()`
  Gets the maximum length of `UserID`
  `int`
  `getUserIDState()`
  Gets the Metadata State of `UserID`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedIdentity`
  `DataSources`
  `Domain`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedIdentity(Identity inObject)`
  Sets the `AssociatedIdentitys` list 0th element to be `inObject`.
  `void`
  `setAssociatedIdentitys(AssociationList list)`
  Sets the `AssociatedIdentitys` list to be `list`.
  `void`
  `setAssociatedIdentitys(AssociationList list, int state)`
  Sets the `AssociatedIdentitys` list to be `list`.
  `void`
  `setDataSources(AssociationList list)`
  Sets the `DataSources` list to be `list`.
  `void`
  `setDataSources(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setDomain(AuthenticationDomain inObject)`
  Sets the `Domains` list 0th element to be `inObject`.
  `void`
  `setDomains(AssociationList list)`
  Sets the `Domains` list to be `list`.
  `void`
  `setDomains(AssociationList list, int state)`
  Sets the `Domains` list to be `list`.
  `void`
  `setLibraries(AssociationList list)`
  Sets the `Libraries` list to be `list`.
  `void`
  `setLibraries(AssociationList inObjects, int state)`
  Sets the entire Libraries list to match the passed in AssociationList, sets the state of the Libraries
  `void`
  `setOutboundOnly(int inOutboundOnly)`
  Sets the `OutboundOnly` value and sets the state to MetadataState.LOCAL.
  `void`
  `setOutboundOnly(int inOutboundOnly, int state)`
  Sets the `OutboundOnly` Metadata State.
  `void`
  `setOutboundOnly(String inOutboundOnly)`
  Sets the `OutboundOnly` value and sets the state to MetadataState.LOCAL.
  `void`
  `setOutboundOnly(String inOutboundOnly, int state)`
  Sets the `OutboundOnly` value and Metadata State.
  `void`
  `setOutboundOnlyState(int state)`
  Sets the Metadata State of `OutboundOnly`.
  `void`
  `setPassword(String inPassword)`
  Sets the `Password` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPassword(String inPassword, int state)`
  Sets the `Password` Metadata State.
  `void`
  `setPasswordState(int state)`
  Sets the Metadata State of `Password`.
  `void`
  `setTrustedOnly(int inTrustedOnly)`
  Sets the `TrustedOnly` value and sets the state to MetadataState.LOCAL.
  `void`
  `setTrustedOnly(int inTrustedOnly, int state)`
  Sets the `TrustedOnly` Metadata State.
  `void`
  `setTrustedOnly(String inTrustedOnly)`
  Sets the `TrustedOnly` value and sets the state to MetadataState.LOCAL.
  `void`
  `setTrustedOnly(String inTrustedOnly, int state)`
  Sets the `TrustedOnly` value and Metadata State.
  `void`
  `setTrustedOnlyState(int state)`
  Sets the Metadata State of `TrustedOnly`.
  `void`
  `setUserID(String inUserID)`
  Sets the `UserID` value and sets the state to MetadataState.LOCAL.
  `void`
  `setUserID(String inUserID, int state)`
  Sets the `UserID` Metadata State.
  `void`
  `setUserIDState(int state)`
  Sets the Metadata State of `UserID`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_USERID_NAME

    static final String ATTRIBUTE_USERID_NAME
    Constant used for the name of the UserID attribute.

    UserID: The user ID used for authentication. The ID must be unique to 128 characters.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PASSWORD_NAME

    static final String ATTRIBUTE_PASSWORD_NAME
    Constant used for the name of the Password attribute.

    Password: This is the password associated with the user ID in this domain.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_TRUSTEDONLY_NAME

    static final String ATTRIBUTE_TRUSTEDONLY_NAME
    Constant used for the name of the TrustedOnly attribute.

    TrustedOnly: Indicates the login will be subject to special access rules.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_OUTBOUNDONLY_NAME

    static final String ATTRIBUTE_OUTBOUNDONLY_NAME
    Constant used for the name of the OutboundOnly attribute.

    OutboundOnly: Indicates that logins within the domain will only be used to establish connections to other servers.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDIDENTITY_NAME

    static final String ASSOCIATION_ASSOCIATEDIDENTITY_NAME
    Constant used for the name of the AssociatedIdentity association.

    AssociatedIdentity: The identity associated with this login.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DATASOURCES_NAME

    static final String ASSOCIATION_DATASOURCES_NAME
    Constant used for the name of the DataSources association.

    DataSources: The data source names that use this login as default.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DOMAIN_NAME

    static final String ASSOCIATION_DOMAIN_NAME
    Constant used for the name of the Domain association.

    Domain: The authorization domain that will authenticate a user to a server using these credentials, i.e. this user ID and password.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LIBRARIES_NAME

    static final String ASSOCIATION_LIBRARIES_NAME
    Constant used for the name of the Libraries association.

    Libraries: The libraries that use this login as a default.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `AssociatedIdentity`
    `DataSources`
    `Domain`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUserID

    String getUserID() throws RemoteException
    Gets the `String` value of `UserID`
    Returns:
      The `UserID`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUserIDState

    int getUserIDState() throws RemoteException
    Gets the Metadata State of `UserID`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUserIDMaxLength

    int getUserIDMaxLength() throws RemoteException
    Gets the maximum length of `UserID`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPassword

    String getPassword() throws RemoteException
    Gets the `String` value of `Password`
    Returns:
      The `Password`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPasswordState

    int getPasswordState() throws RemoteException
    Gets the Metadata State of `Password`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPasswordMaxLength

    int getPasswordMaxLength() throws RemoteException
    Gets the maximum length of `Password`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTrustedOnly

    int getTrustedOnly() throws RemoteException
    Gets the `int` value of `TrustedOnly`
    Returns:
      The `TrustedOnly`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTrustedOnlyState

    int getTrustedOnlyState() throws RemoteException
    Gets the Metadata State of `TrustedOnly`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getOutboundOnly

    int getOutboundOnly() throws RemoteException
    Gets the `int` value of `OutboundOnly`
    Returns:
      The `OutboundOnly`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getOutboundOnlyState

    int getOutboundOnlyState() throws RemoteException
    Gets the Metadata State of `OutboundOnly`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedIdentitys

    AssociationList getAssociatedIdentitys() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedIdentitys`
    Returns:
      Returns the AssociationList of `AssociatedIdentitys` which can be of type:
      Identity
      IdentityGroup
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedIdentity

    Identity getAssociatedIdentity() throws RemoteException, MdException
    Gets the `Identity` for `AssociatedIdentity`
    Returns:
      The `Identity` ( `null` if not set) of `AssociatedIdentity`which can be of type:
      Identity
      IdentityGroup
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDataSources

    AssociationList getDataSources() throws RemoteException, MdException
    Gets the AssociationList of `DataSources`
    Returns:
      Returns the AssociationList of `DataSources` which can be of type:
      DataSourceName
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDomains

    AssociationList getDomains() throws RemoteException, MdException
    Gets the AssociationList of `Domains`
    Returns:
      Returns the AssociationList of `Domains` which can be of type:
      AuthenticationDomain
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getDomain

    AuthenticationDomain getDomain() throws RemoteException, MdException
    Gets the `AuthenticationDomain` for `Domain`
    Returns:
      The `AuthenticationDomain` ( `null` if not set) of `Domain`which can be of type:
      AuthenticationDomain
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLibraries

    AssociationList getLibraries() throws RemoteException, MdException
    Gets the Association list of `Libraries`
    Returns:
      The AssociationList of `Libraries` which can be of type:
      SASLibrary
      SecuredLibrary
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedIdentitys

    AssociationList getAssociatedIdentitys(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedIdentitys`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedIdentitys` which can be of type:
      Identity
      IdentityGroup
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDataSources

    AssociationList getDataSources(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `DataSources`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `DataSources` which can be of type:
      DataSourceName
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDomains

    AssociationList getDomains(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Domains`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Domains` which can be of type:
      AuthenticationDomain
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLibraries

    AssociationList getLibraries(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Libraries`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Libraries` which can be of type:
      SASLibrary
      SecuredLibrary
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setUserID

    void setUserID(String inUserID) throws RemoteException
    Sets the `UserID` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inUserID` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUserID

    void setUserID(String inUserID, int state) throws RemoteException
    Sets the `UserID` Metadata State.
    Parameters:
      `inUserID` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUserIDState

    void setUserIDState(int state) throws RemoteException
    Sets the Metadata State of `UserID`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPassword

    void setPassword(String inPassword) throws RemoteException
    Sets the `Password` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPassword` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPassword

    void setPassword(String inPassword, int state) throws RemoteException
    Sets the `Password` Metadata State.
    Parameters:
      `inPassword` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPasswordState

    void setPasswordState(int state) throws RemoteException
    Sets the Metadata State of `Password`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTrustedOnly

    void setTrustedOnly(int inTrustedOnly) throws RemoteException
    Sets the `TrustedOnly` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inTrustedOnly` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTrustedOnly

    void setTrustedOnly(int inTrustedOnly, int state) throws RemoteException
    Sets the `TrustedOnly` Metadata State.
    Parameters:
      `inTrustedOnly` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTrustedOnly

    void setTrustedOnly(String inTrustedOnly) throws RemoteException
    Sets the `TrustedOnly` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inTrustedOnly` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTrustedOnly

    void setTrustedOnly(String inTrustedOnly, int state) throws RemoteException
    Sets the `TrustedOnly` value and Metadata State.
    Parameters:
      `inTrustedOnly` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTrustedOnlyState

    void setTrustedOnlyState(int state) throws RemoteException
    Sets the Metadata State of `TrustedOnly`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOutboundOnly

    void setOutboundOnly(int inOutboundOnly) throws RemoteException
    Sets the `OutboundOnly` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inOutboundOnly` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOutboundOnly

    void setOutboundOnly(int inOutboundOnly, int state) throws RemoteException
    Sets the `OutboundOnly` Metadata State.
    Parameters:
      `inOutboundOnly` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOutboundOnly

    void setOutboundOnly(String inOutboundOnly) throws RemoteException
    Sets the `OutboundOnly` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inOutboundOnly` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOutboundOnly

    void setOutboundOnly(String inOutboundOnly, int state) throws RemoteException
    Sets the `OutboundOnly` value and Metadata State.
    Parameters:
      `inOutboundOnly` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOutboundOnlyState

    void setOutboundOnlyState(int state) throws RemoteException
    Sets the Metadata State of `OutboundOnly`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedIdentitys

    void setAssociatedIdentitys(AssociationList list) throws RemoteException
    Sets the `AssociatedIdentitys` list to be `list`. Object of which can be of type:
    Identity
    IdentityGroup
    Person
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedIdentitys

    void setAssociatedIdentitys(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedIdentitys` list to be `list`. Object of which can be of type:
    Identity
    IdentityGroup
    Person
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedIdentity

    void setAssociatedIdentity(Identity inObject) throws RemoteException
    Sets the `AssociatedIdentitys` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Identity
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDataSources

    void setDataSources(AssociationList list) throws RemoteException
    Sets the `DataSources` list to be `list`. Objects of which can be of type:
    DataSourceName
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDataSources

    void setDataSources(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDomains

    void setDomains(AssociationList list) throws RemoteException
    Sets the `Domains` list to be `list`. Object of which can be of type:
    AuthenticationDomain
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDomains

    void setDomains(AssociationList list, int state) throws RemoteException
    Sets the `Domains` list to be `list`. Object of which can be of type:
    AuthenticationDomain
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDomain

    void setDomain(AuthenticationDomain inObject) throws RemoteException
    Sets the `Domains` list 0th element to be `inObject`.
    Parameters:
      `inObject` - AuthenticationDomain
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLibraries

    void setLibraries(AssociationList list) throws RemoteException
    Sets the `Libraries` list to be `list`. Objects of which can be of type:
    SASLibrary
    SecuredLibrary
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLibraries

    void setLibraries(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Libraries list to match the passed in AssociationList, sets the state of the Libraries
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.